# Class CacheManager

java.lang.Object
org.apache.jmeter.testelement.AbstractTestElement
org.apache.jmeter.config.ConfigTestElement
org.apache.jmeter.protocol.http.control.CacheManager

All Implemented Interfaces:
  `Serializable, Cloneable, ConfigElement, Searchable, TestElement, TestIterationListener, TestStateListener`

public class CacheManager extends ConfigTestElement implements TestStateListener, TestIterationListener, Serializable
Handles HTTP Caching

See Also:
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`CLEAR`
`static final String`
`MAX_SIZE`
`static final String`
`USE_EXPIRES`

### Fields inherited from class ConfigTestElement

`PASSWORD, USERNAME`

### Fields inherited from interface TestElement

`COMMENTS, ENABLED, GUI_CLASS, NAME, TEST_CLASS`

## Constructor Summary

Constructors
Constructor
Description
`CacheManager()`

## Method Summary

Modifier and Type
Method
Description
`void`
`clear()`
Clear the TestElement of all data.
`boolean`
`getClearEachIteration()`
`int`
`getMaxSize()`
`boolean`
`getUseExpires()`
`boolean`
`inCache(URL url)`
Check the cache, if the entry has an expires header and the entry has not expired, return true
`void`
`saveDetails(HttpMethod method, HTTPSampleResult res)`
Save the Last-Modified, Etag, and Expires headers if the result is cacheable.
`void`
`saveDetails(HttpResponse method, HTTPSampleResult res)`
Save the Last-Modified, Etag, and Expires headers if the result is cacheable.
`void`
`saveDetails(URLConnection conn, HTTPSampleResult res)`
Save the Last-Modified, Etag, and Expires headers if the result is cacheable.
`void`
`setClearEachIteration(boolean clear)`
`void`
`setHeaders(HttpURLConnection conn, URL url)`
Check the cache, and if there is a match, set the headers: If-Modified-Since If-None-Match
`void`
`setHeaders(URL url, HttpMethod method)`
Check the cache, and if there is a match, set the headers: If-Modified-Since If-None-Match Commons HttpClient version
`void`
`setHeaders(URL url, HttpRequestBase request)`
Check the cache, and if there is a match, set the headers: If-Modified-Since If-None-Match Apache HttpClient version.
`void`
`setMaxSize(int size)`
`void`
`setUseExpires(boolean expires)`
`void`
`testEnded()`
Called once for all threads after the end of a test.
`void`
`testEnded(String host)`
Called once for all threads after the end of a test.
`void`
`testIterationStart(LoopIterationEvent event)`
Each time through a Thread Group's test script, an iteration event is fired for each thread.
`void`
`testStarted()`
Called just before the start of the test from the main engine thread.
`void`
`testStarted(String host)`
Called just before the start of the test from the main engine thread.

### Methods inherited from class ConfigTestElement

`addConfigElement, addTestElement, expectsModification`

### Methods inherited from class AbstractTestElement

`addPropertiesValues, addProperty, addProperty, canRemove, clearTemporary, clearTestElementChildren, clone, emptyTemporary, equals, getComment, getName, getProperty, getPropertyAsBoolean, getPropertyAsBoolean, getPropertyAsDouble, getPropertyAsFloat, getPropertyAsInt, getPropertyAsInt, getPropertyAsLong, getPropertyAsLong, getPropertyAsString, getPropertyAsString, getSearchableTokens, getThreadContext, getThreadName, hashCode, isEnabled, isRunningVersion, isTemporary, logProperties, mergeIn, propertyIterator, recoverRunningVersion, removeProperty, setComment, setEnabled, setName, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setRunningVersion, setTemporary, setThreadContext, setThreadName, traverse, traverseCollection, traverseMap, traverseProperty`

### Methods inherited from class Object

`finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface ConfigElement

`clone`

## Field Details

### CLEAR

public static final String CLEAR

See Also:
  - Constant Field Values

### USE_EXPIRES

public static final String USE_EXPIRES

See Also:
  - Constant Field Values

### MAX_SIZE

public static final String MAX_SIZE

See Also:
  - Constant Field Values

## Constructor Details

### CacheManager

public CacheManager()

## Method Details

### saveDetails

public void saveDetails(URLConnection conn, HTTPSampleResult res)
Save the Last-Modified, Etag, and Expires headers if the result is cacheable. Version for Java implementation.

Parameters:
  `conn` - connection
  `res` - result

### saveDetails

public void saveDetails(HttpMethod method, HTTPSampleResult res) throws URIException
Save the Last-Modified, Etag, and Expires headers if the result is cacheable. Version for Commons HttpClient implementation.

Parameters:
  `method` -
  invalid reference

      HttpMethod

  to get header information from
  `res` - result to decide if result is cacheable

### saveDetails

public void saveDetails(HttpResponse method, HTTPSampleResult res)
Save the Last-Modified, Etag, and Expires headers if the result is cacheable. Version for Apache HttpClient implementation.

Parameters:
  `method` -
  invalid reference

      HttpResponse

  to extract header information from
  `res` - result to decide if result is cacheable

### setHeaders

public void setHeaders(URL url, HttpMethod method)
Check the cache, and if there is a match, set the headers:

- If-Modified-Since
- If-None-Match

Commons HttpClient version

Parameters:
  `url` - URL to look up in cache
  `method` - where to set the headers

### setHeaders

public void setHeaders(URL url, HttpRequestBase request)
Check the cache, and if there is a match, set the headers:

- If-Modified-Since
- If-None-Match

Apache HttpClient version.

Parameters:
  `url` - `URL` to look up in cache
  `request` - where to set the headers

### setHeaders

public void setHeaders(HttpURLConnection conn, URL url)
Check the cache, and if there is a match, set the headers:

- If-Modified-Since
- If-None-Match

Parameters:
  `conn` - where to set the headers
  `url` - `URL` to look up in cache

### inCache

public boolean inCache(URL url)
Check the cache, if the entry has an expires header and the entry has not expired, return true

Parameters:
  `url` - `URL` to look up in cache
Returns:
  `true` if entry has an expires header and the entry has not expired, else `false`

### getClearEachIteration

public boolean getClearEachIteration()

### setClearEachIteration

public void setClearEachIteration(boolean clear)

### getUseExpires

public boolean getUseExpires()

### setUseExpires

public void setUseExpires(boolean expires)

### getMaxSize

public int getMaxSize()

Returns:
  int cache max size

### setMaxSize

public void setMaxSize(int size)

Parameters:
  `size` - int cache max size

### clear

public void clear()
Description copied from class: `AbstractTestElement`
Clear the TestElement of all data.

Specified by:
  `clear` in interface `TestElement`
Overrides:
  `clear` in class `AbstractTestElement`

### testStarted

public void testStarted()
Description copied from interface: `TestStateListener`

Called just before the start of the test from the main engine thread. This is before the test elements are cloned. Note that not all the test variables will have been set up at this point.

N.B. testStarted() and testEnded() are called from different threads.

Specified by:
  `testStarted` in interface `TestStateListener`
See Also:
  - `StandardJMeterEngine.run()`

### testEnded

public void testEnded()
Description copied from interface: `TestStateListener`

Called once for all threads after the end of a test. This will use the same element instances as at the start of the test.

N.B. testStarted() and testEnded() are called from different threads.

Specified by:
  `testEnded` in interface `TestStateListener`
See Also:
  - `StandardJMeterEngine.stopTest()`

### testStarted

public void testStarted(String host)
Description copied from interface: `TestStateListener`

Called just before the start of the test from the main engine thread. This is before the test elements are cloned. Note that not all the test variables will have been set up at this point.

N.B. testStarted() and testEnded() are called from different threads.

Specified by:
  `testStarted` in interface `TestStateListener`
Parameters:
  `host` - name of host
See Also:
  - `StandardJMeterEngine.run()`

### testEnded

public void testEnded(String host)
Description copied from interface: `TestStateListener`

Called once for all threads after the end of a test. This will use the same element instances as at the start of the test.

N.B. testStarted() and testEnded() are called from different threads.

Specified by:
  `testEnded` in interface `TestStateListener`
Parameters:
  `host` - name of host
See Also:
  - `StandardJMeterEngine.stopTest()`

### testIterationStart

public void testIterationStart(LoopIterationEvent event)
Description copied from interface: `TestIterationListener`
Each time through a Thread Group's test script, an iteration event is fired for each thread. This will be after the test elements have been cloned, so in general the instance will not be the same as the ones the start/end methods call.

Specified by:
  `testIterationStart` in interface `TestIterationListener`
Parameters:
  `event` - the iteration event